/* Program TSA2GP.C */
/* By Harald Stauss */
/* Last change 04.11.95 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "tsa.h"
#include <iostream.h>
#include <fstream.h>

main(int argc, char *argv[])
{
  short    i;
  unsigned long  n,ew;
  REGIST   r;
  char     *fin,*ftin,*fout,*ftout;
  float    ef,sr;
  ofstream outdat;

  /* H e l l o   w o r l d */
  cout << "TSA2GP Ver.1.0 by H. Stauss, 1995 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255);
  fout=(char *)malloc(255);
  ftin=(char *)malloc(255);
  ftout=(char *)malloc(255);

  /* P a r a m e t e r   e i n l e s e n */
  if (argc!=4 && argc!=5)
    {
      cout << "Number of parameters wrong! \n";
      cout << "tsa2gp f_in f_out ef [sr] \n";
      cout << "makes file for gnuplot splot \n";
      cout << "f_in  : name of input file (*.TSA, *.ASC). \n";
      cout << "f_out : name of output file (*.TSA, *.ASC). \n";
      cout << "ef    : end frequency for spectrum. \n";
      cout << "sr    : sampling rate for ASCII files. \n";
      goto ende;
    }
  strcpy(fin,argv[1]);
  strcpy(fout,argv[2]);
  strcpy(ftin,fin);
  strcpy(ftout,fout);
  ftin=strrchr(ftin,'.');
  for (i=0; ftin[i]; i++) ftin[i]=toupper(ftin[i]);
  ftout=strrchr(ftout,'.');
  for (i=0; ftout[i]; i++) ftout[i]=toupper(ftout[i]);
  sscanf(argv[3],"%f",&ef);
  if (strcmp(ftin,".ASC")==0 && argc!=5) {
    cout << "need sampling rate for ASCII files! \n";
    goto ende;
  }
  if (strcmp(ftin,".ASC")==0) sscanf(argv[4],"%f",&sr);

  printf("Input file  : %s \n",fin);
  printf("Output file : %s \n",fout);

  /* E i n g a b e d a t e i   o e f f n e n */
  if (strcmp(ftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(ftin,".ASC")==0) r.ReadASCII(fin,sr);
  if ((strcmp(ftin,".TSA")!=0) && (strcmp(ftin,".ASC")!=0)) {
    cout << "File type for input not recognized! \n";
    goto ende;
  }
  printf("Number of channels   : %d  \n",r.n);
  cout << "end frequency : " << ef << "\n";

  sr=r.ch[0].sr;
  for (i=0; i<r.n; i++)
    if (sr!=r.ch[i].sr) {
      cout << "sampling rate must be equal in all channels! \n";
      goto ende;
    }

  cout << "sampling rate: " << sr << "\n";

  outdat.open(fout);
  if(!outdat){
    cout << "cant open output file \n";
    goto ende;
  }

  /* M A I N L O O P  */
  for (i=0; i < r.n; i++) {
    ew=(unsigned long) (2*(r.ch[i].n-1)*ef/sr);
    cout << "endwert: " << ew << "\n";
    for (n=0; n<=ew; n++) {
      outdat << n*sr/(r.ch[i].n-1)/2 << "\t" << i+1 << "\t" << r.ch[i].data[n] << "\n";
    }
    outdat << "\n";
  } /* endfor */

  outdat.close();

 ende:
  free(fin);free(ftin);free(fout);free(ftout);
  return(0);
} /* Ende von main */
